/* einfacher TCP-basierter Echo-Server, der alle Requests von einem neuen
   Prozess bearbeiten laesst
   (c) 1999 C. Hutter  <hutter@uni-trier.de>  */

#include <sys/types.h>
#include <sys/socket.h>
#include <strings.h>
#include <netinet/in.h>
#include <stdio.h>

int main(void)
{
  int listenSocket,acceptSocket;
  int listenPort=5000;
  struct sockaddr_in serverAddr,clientAddr;
  int clientAddrSize,childpid=1;
  char message[1000];
  int messageLen,bytesReceived,bytesSent;
  
  messageLen=sizeof(message);
  
  /* Socketgenerierung */
  listenSocket=socket(AF_INET,SOCK_STREAM,0);
  if(listenSocket<1)
    {
      printf("listen failed\n");
      exit(-1);
    }

  /* Struct fuellen */
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(listenPort);
  serverAddr.sin_addr.s_addr=inet_addr("136.199.54.228"); /* anpassen */
  bzero(&(serverAddr.sin_zero),8);
  
  /* Namen an Socket binden */
  if (bind(listenSocket,(struct sockaddr *)&serverAddr,sizeof(struct sockaddr))<0)
    {
      printf("bind failed\n");
      exit(-1);
    }
  
  /* an Socket horchen */
  if (listen(listenSocket,1)<0)
    {
      printf("listen failed\n");
      exit(-1);
    }
  
  for(;;) /* Endlosschleife des Servers */
    {
      /* warten, dass ein Client eine Verbindung will */
      acceptSocket=accept(listenSocket,(struct sockaddr_in*)&clientAddr,&clientAddrSize);
      if(acceptSocket<0)
	{
	  printf("accept failed\n");
	  exit(-1);
	}
      /* die Arbeit macht ein neuer Prozess */
      childpid = fork();
      if (childpid==0) /* das ist der neue Prozess */
	{
	  close (listenSocket); /* diesen Socket braucht man nur um auf 
				   Verbindungswuensche zu warten */
	  bzero(message,messageLen);
	  /*empfangen der Nachricht */
	  bytesReceived=recv(acceptSocket,message,messageLen,0);
	  printf("empfange::%s",message);
	  fflush(stdout);
	  sleep(5); /* da koennte jetzt richtig was gearbeitet werden */
	  /* sende Nachricht zurueck */
	  bytesSent=send(acceptSocket,message,bytesReceived,0);
	  close(acceptSocket); /*den brauchen wir jetzt nicht mehr */
	  exit(0); /* fertig, der "Neue" wird nicht mehr gebraucht */
	}
      close(acceptSocket); /* das ist wieder der urspruengliche Prozess,
			      der braucht den Socket natuerlich auch nicht
			      mehr, den braucht ja nur der "Neue" */
    }
}
